import { sequelize } from '../../../modules/sequelize.ts';
import { DataTypes, Model } from 'sequelize';

export interface PageData {
  edges: any[];
  nodes: any[];
  viewport: any;
  [key: string]: any;
}
export class PageModel extends Model {
  declare id: string;
  declare title: string;
  declare description: string;
  declare type: string;
  declare data: PageData;
}
PageModel.init(
  {
    id: {
      type: DataTypes.UUID,
      primaryKey: true,
      defaultValue: DataTypes.UUIDV4,
      comment: 'id',
    },
    title: {
      type: DataTypes.STRING,
      defaultValue: '',
    },
    description: {
      type: DataTypes.TEXT,
      defaultValue: '',
    },
    type: {
      type: DataTypes.STRING,
      defaultValue: '',
    },
    data: {
      type: DataTypes.JSON,
      defaultValue: {},
    },
    uid: {
      type: DataTypes.UUID,
      allowNull: true,
    },
  },
  {
    sequelize,
    tableName: 'kv_page',
  },
);

PageModel.sync({ alter: true, logging: false }).catch((e) => {
  console.error('PageModel sync', e);
});
